diff --git a/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java b/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java
new file mode 100644
index 000000000..c5d1a7170
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/CloneCommand.java
@@ -0,0 +1,192 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.ArgumentBuilder;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.context.CommandContext;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.BlockArgumentType;
+import net.minecraft.core.net.command.arguments.DimensionArgumentType;
+import net.minecraft.core.net.command.arguments.IntegerCoordinatesArgumentType;
+import net.minecraft.core.net.command.helpers.BlockInput;
+import net.minecraft.core.net.command.helpers.ClonedBlock;
+import net.minecraft.core.net.command.helpers.IntegerCoordinate;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.HashMap;
+import java.util.Map;
+
+public class CloneCommand {
+    private static final SimpleCommandExceptionType INSIDE_CLONED_AREA = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_inside_cloned_area"));
+    private static final SimpleCommandExceptionType DESTINATION_NOT_LOADED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_destination_not_loaded"));
+    private static final SimpleCommandExceptionType SOURCE_NOT_LOADED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_source_not_loaded"));
+    private static final SimpleCommandExceptionType NOWHERE_LOADED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.clone.exception_nowhere_loaded"));
+
+    public static void register(CommandDispatcher<CommandSource> commandDispatcher) {
+        commandDispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("clone")
+                .requires(CommandSource::hasAdmin)
+                .then(beginEndDestinationAndModeSuffix(c -> {
+                    return c.getSource().getWorld();
+                }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("from")
+                        .then((RequiredArgumentBuilder.<CommandSource, Dimension>argument("sourceDimension", DimensionArgumentType.dimension()))
+                                .then(beginEndDestinationAndModeSuffix(c -> {
+                                    return c.getSource().getWorld(c.getArgument("sourceDimension", Dimension.class).id);
+                                })))));
+    }
+
+    private static ArgumentBuilder<CommandSource, ?> beginEndDestinationAndModeSuffix(CommandFunction<CommandContext<CommandSource>, World> commandFunction) {
+        return RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("begin", IntegerCoordinatesArgumentType.intCoordinates())
+                .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("end", IntegerCoordinatesArgumentType.intCoordinates())
+                        .then(destinationAndModeSuffix(commandFunction, c -> {
+                            return c.getSource().getWorld();
+                        }))
+                        .then(LiteralArgumentBuilder.<CommandSource>literal("to")
+                                .then((RequiredArgumentBuilder.<CommandSource, Dimension>argument("targetDimension", DimensionArgumentType.dimension()))
+                                        .then(destinationAndModeSuffix(commandFunction, c -> {
+                                            return c.getSource().getWorld(c.getArgument("targetDimension", Dimension.class).id);
+                                        })))));
+    }
+
+    private static WorldAndPosition getWorldAndPosition(CommandContext<CommandSource> commandContext, World world, String string) {
+        IntegerCoordinates coordinates = commandContext.getArgument(string, IntegerCoordinates.class);
+        return new WorldAndPosition(world, coordinates);
+    }
+
+    private static ArgumentBuilder<CommandSource, ?> destinationAndModeSuffix(CommandFunction<CommandContext<CommandSource>, World> commandFunction, CommandFunction<CommandContext<CommandSource>, World> commandFunction2) {
+        CommandFunction<CommandContext<CommandSource>, WorldAndPosition> commandFunction3 = c -> getWorldAndPosition(c, commandFunction.apply(c), "begin");
+        CommandFunction<CommandContext<CommandSource>, WorldAndPosition> commandFunction4 = c -> getWorldAndPosition(c, commandFunction.apply(c), "end");
+        CommandFunction<CommandContext<CommandSource>, WorldAndPosition> commandFunction5 = c -> getWorldAndPosition(c, commandFunction2.apply(c), "destination");
+        return RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("destination", IntegerCoordinatesArgumentType.intCoordinates())
+                .executes(c -> {
+                    return clone(c.getSource(), commandFunction3.apply(c), commandFunction4.apply(c), commandFunction5.apply(c), null, CloneMode.NORMAL);
+                })
+                .then(wrapWithCloneMode(commandFunction3, commandFunction4, commandFunction5, (commandContext) -> null, LiteralArgumentBuilder.<CommandSource>literal("replace")
+                        .executes(c -> {
+                            return clone(c.getSource(), commandFunction3.apply(c), commandFunction4.apply(c), commandFunction5.apply(c), null, CloneMode.NORMAL);
+                        })))
+                .then(wrapWithCloneMode(commandFunction3, commandFunction4, commandFunction5, commandContext -> new BlockInput(null, 0, new CompoundTag()), LiteralArgumentBuilder.<CommandSource>literal("masked")
+                        .executes(c -> {
+                            return clone(c.getSource(), commandFunction3.apply(c), commandFunction4.apply(c), commandFunction5.apply(c), new BlockInput(null, 0, new CompoundTag()), CloneMode.NORMAL);
+                        })))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("filtered")
+                        .then(wrapWithCloneMode(commandFunction3, commandFunction4, commandFunction5, c -> {
+                            return c.getArgument("filter", BlockInput.class);
+                            }, RequiredArgumentBuilder.<CommandSource, BlockInput>argument("filter", BlockArgumentType.block())
+                                .executes(c -> {
+                                    return clone(c.getSource(), commandFunction3.apply(c), commandFunction4.apply(c), commandFunction5.apply(c), c.getArgument("filter", BlockInput.class), CloneMode.NORMAL);
+                                }))));
+    }
+
+    private static ArgumentBuilder<CommandSource, ?> wrapWithCloneMode(CommandFunction<CommandContext<CommandSource>, WorldAndPosition> commandFunction, CommandFunction<CommandContext<CommandSource>, WorldAndPosition> commandFunction2, CommandFunction<CommandContext<CommandSource>, WorldAndPosition> commandFunction3, CommandFunction<CommandContext<CommandSource>, BlockInput> commandFunction4, ArgumentBuilder<CommandSource, ?> argumentBuilder) {
+        return argumentBuilder.then(LiteralArgumentBuilder.<CommandSource>literal("force")
+                .executes(c -> {
+                    return clone(c.getSource(), commandFunction.apply(c), commandFunction2.apply(c), commandFunction3.apply(c), commandFunction4.apply(c), CloneMode.FORCE);
+                }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("move")
+                        .executes(c -> {
+                            return clone(c.getSource(), commandFunction.apply(c), commandFunction2.apply(c), commandFunction3.apply(c), commandFunction4.apply(c), CloneMode.MOVE);
+                        }))
+                .then(LiteralArgumentBuilder.<CommandSource>literal("normal")
+                        .executes(c -> {
+                            return clone(c.getSource(), commandFunction.apply(c), commandFunction2.apply(c), commandFunction3.apply(c), commandFunction4.apply(c), CloneMode.NORMAL);
+                        }));
+    }
+
+    @FunctionalInterface
+    interface CommandFunction<T, R> {
+        R apply(T object) throws CommandSyntaxException;
+    }
+
+    public static class WorldAndPosition {
+        private final World world;
+        private final IntegerCoordinates position;
+
+        WorldAndPosition(World world, IntegerCoordinates position) {
+            this.world = world;
+            this.position = position;
+        }
+
+        public World getWorld() {
+            return this.world;
+        }
+
+        public IntegerCoordinates getPosition() {
+            return this.position;
+        }
+    }
+
+    public static int clone(CommandSource source, WorldAndPosition start, WorldAndPosition end, WorldAndPosition destination, @Nullable BlockInput filter, CloneMode cloneMode) throws CommandSyntaxException {
+        int minX = Math.min(start.getPosition().getX(source), end.getPosition().getX(source));
+        int minY = Math.min(start.getPosition().getY(source, true), end.getPosition().getY(source, true));
+        int minZ = Math.min(start.getPosition().getZ(source), end.getPosition().getZ(source));
+        int maxX = Math.max(start.getPosition().getX(source), end.getPosition().getX(source));
+        int maxY = Math.max(start.getPosition().getY(source, true), end.getPosition().getY(source, true));
+        int maxZ = Math.max(start.getPosition().getZ(source), end.getPosition().getZ(source));
+
+        int destinationX = destination.getPosition().getX(source);
+        int destinationY = destination.getPosition().getY(source, true);
+        int destinationZ = destination.getPosition().getZ(source);
+
+        if (cloneMode == CloneMode.NORMAL && AABB.getTemporaryBB(minX, minY, minZ, maxX, maxY, maxZ).contains(Vec3.getTempVec3(destinationX, destinationY, destinationZ)) && start.getWorld() == destination.getWorld()) {
+            throw INSIDE_CLONED_AREA.create();
+        }
+
+        start.getWorld().editingBlocks = true;
+        Map<IntegerCoordinates, ClonedBlock> map = new HashMap<>();
+        for (int x = minX; x <= maxX; x++) {
+            for (int y = minY; y <= maxY; y++) {
+                for (int z = minZ; z <= maxZ; z++) {
+                    if (!start.getWorld().isBlockLoaded(x, y, z)) {
+                        if (!destination.getWorld().isBlockLoaded(destinationX, destinationY, destinationZ)) throw NOWHERE_LOADED.create();
+                        else throw SOURCE_NOT_LOADED.create();
+                    }
+                    map.put(new IntegerCoordinates(new IntegerCoordinate(false, x - minX), new IntegerCoordinate(false, y - minY), new IntegerCoordinate(false, z - minZ)), new ClonedBlock(start.getWorld().getBlock(x, y, z), start.getWorld().getBlockMetadata(x, y, z), start.getWorld().getBlockEntity(x, y, z)));
+                    if (cloneMode == CloneMode.MOVE) {
+                        start.getWorld().setBlockWithNotify(x, y, z, 0);
+                    }
+                }
+            }
+        }
+        if (!destination.getWorld().isBlockLoaded(destinationX, destinationY, destinationZ)) throw DESTINATION_NOT_LOADED.create();
+        start.getWorld().editingBlocks = false;
+
+        int clonedBlocks = 0;
+        destination.getWorld().editingBlocks = true;
+        for (Map.Entry<IntegerCoordinates, ClonedBlock> entry : map.entrySet()) {
+            int offsetDestinationX = destinationX + entry.getKey().getX(source);
+            int offsetDestinationY = destinationY + entry.getKey().getY(source, true);
+            int offsetDestinationZ = destinationZ + entry.getKey().getZ(source);
+            CompoundTag blockTag = new CompoundTag();
+            BlockEntity blockEntity = destination.getWorld().getBlockEntity(offsetDestinationX, offsetDestinationY, offsetDestinationZ);
+            if (blockEntity != null) blockEntity.writeToNBT(blockTag);
+            if (filter == null || (destination.getWorld().getBlockId(offsetDestinationX, offsetDestinationY, offsetDestinationZ) == filter.getBlockId() && destination.getWorld().getBlockMetadata(offsetDestinationX, offsetDestinationY, offsetDestinationZ) == filter.getMetadata() && (filter.getTag().getValues().isEmpty() || CommandHelper.blockEntitiesAreEqual(blockTag, filter.getTag())))) {
+                if (destination.getWorld().getBlockId(offsetDestinationX, offsetDestinationY, offsetDestinationZ) != entry.getValue().getBlockId() || destination.getWorld().getBlockMetadata(offsetDestinationX, offsetDestinationY, offsetDestinationZ) != entry.getValue().getMetadata()) ++clonedBlocks;
+                destination.getWorld().setBlockWithNotify(offsetDestinationX, offsetDestinationY, offsetDestinationZ, entry.getValue().getBlockId());
+                destination.getWorld().setBlockMetadataWithNotify(offsetDestinationX, offsetDestinationY, offsetDestinationZ, entry.getValue().getMetadata());
+                CommandHelper.setBlockEntity(destination.getWorld(), offsetDestinationX, offsetDestinationY, offsetDestinationZ, entry.getValue().getBlockEntity());
+            }
+        }
+        destination.getWorld().editingBlocks = false;
+        source.sendTranslatableMessage(clonedBlocks == 1 ? "command.commands.clone.success_single" : "command.commands.clone.success_multiple", clonedBlocks);
+        return clonedBlocks;
+    }
+
+    public enum CloneMode {
+        FORCE,
+        MOVE,
+        NORMAL
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/DamageCommand.java b/src/main/java/net/minecraft/core/net/command/commands/DamageCommand.java
new file mode 100644
index 000000000..f1cad1e5b
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/DamageCommand.java
@@ -0,0 +1,35 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.IntegerArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.DamageTypeArgumentType;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+
+import java.util.List;
+
+public class DamageCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("damage")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", EntityArgumentType.entities())
+                        .then(RequiredArgumentBuilder.<CommandSource, DamageType>argument("type", DamageTypeArgumentType.damageType())
+                                .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("amount", IntegerArgumentType.integer(0, 32768))
+                                        .executes(c -> {
+                                            List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(c.getSource());
+                                            DamageType type = c.getArgument("type", DamageType.class);
+                                            int amount = c.getArgument("amount", Integer.class);
+                                            int entitiesAffected = 0;
+                                            for (Entity entity : entities) {
+                                                if (entity.hurt(null, amount, type)) ++entitiesAffected;
+                                            }
+                                            c.getSource().sendTranslatableMessage("command.commands.damage.success_" + (entitiesAffected == 1 ? "single" : "multiple"), entitiesAffected);
+                                            return entitiesAffected;
+                                        })))));
+    }
+}
